Apache log4cxx: PropertyConfigurator Class Reference

- Main Page
- Modules
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# PropertyConfigurator Class Reference

Inherits Configurator, and ObjectImpl.

List of all members.

## Detailed Description

Allows the configuration of log4cxx from an external file.

See doConfigure(const File&, log4cxx::spi::LoggerRepositoryPtr&) for the expected format.

It is sometimes useful to see how log4cxx is reading configuration files. You can enable log4cxx internal logging by defining the log4j.debug variable.

At class initialization time class, the file log4j.properties will be searched in the current directory. If the file can be found, then it will be fed to the PropertyConfigurator#configure(const File& configFilename) method.

The `PropertyConfigurator` does not handle the advanced configuration features supported by the DOMConfigurator such as support for Filters, custom ErrorHandlers, nested appenders such as the AsyncAppender, etc.

All option values admit variable substitution. The syntax of variable substitution is similar to that of Unix shells. The string between an opening "${" and closing "}" is interpreted as a key. The value of the substituted variable can be defined as a system property or in the configuration file itself. The value of the key is first searched in the system properties, and if not found there, it is then searched in the configuration file being parsed. The corresponding value replaces the ${variableName} sequence. For example, if `java.home` system property is set to `/home/xyz`, then every occurrence of the sequence `${java.home}` will be interpreted as `/home/xyz`.

## Public Member Functions
| PropertyConfigurator ()
virtual | ~PropertyConfigurator ()
void | addRef () const
void | releaseRef () const
void | doConfigure (const File &configFileName, spi::LoggerRepositoryPtr &hierarchy)
| Read configuration from a file.
void | doConfigure (helpers::Properties &properties, spi::LoggerRepositoryPtr &hierarchy)
| Read configuration options from `properties`.
## Static Public Member Functions
static void | configure (const File &configFilename)
| Read configuration options from file `configFilename`.
static void | configureAndWatch (const File &configFilename)
| Like configureAndWatch(const File& configFilename, long delay) except that the default delay as defined by helpers::FileWatchdog::DEFAULT_DELAY is used.
static void | configureAndWatch (const File &configFilename, long delay)
| Read the configuration file `configFilename` if it exists.
static void | configure (helpers::Properties &properties)
| Read configuration options from `properties`.
## Protected Member Functions
void | configureLoggerFactory (helpers::Properties &props)
| Check the provided `Properties` object for a loggerFactory entry specified by LOGGER_FACTORY_KEY.
void | configureRootLogger (helpers::Properties &props, spi::LoggerRepositoryPtr &hierarchy)
void | parseCatsAndRenderers (helpers::Properties &props, spi::LoggerRepositoryPtr &hierarchy)
| Parse non-root elements, such non-root categories and renderers.
void | parseAdditivityForLogger (helpers::Properties &props, LoggerPtr &cat, const LogString &loggerName)
| Parse the additivity option for a non-root logger.
void | parseLogger (helpers::Properties &props, LoggerPtr &logger, const LogString &optionKey, const LogString &loggerName, const LogString &value)
| This method must work for the root logger as well.
AppenderPtr | parseAppender (helpers::Properties &props, const LogString &appenderName)
void | registryPut (const AppenderPtr &appender)
AppenderPtr | registryGet (const LogString &name)
## Protected Attributes
std::map< LogString, AppenderPtr > * | registry
| Used internally to keep track of configured appenders.
helpers::ObjectPtrT< spi::LoggerFactory > | loggerFactory
| Used to create new instances of logger.

## Constructor & Destructor Documentation

PropertyConfigurator | ( |  | ) |

virtual ~PropertyConfigurator | ( |  | ) | `[virtual]`

## Member Function Documentation

void addRef | ( |  | ) | const`[virtual]`

| Reimplemented from ObjectImpl.

static void configure | ( | helpers::Properties & | properties | ) | `[static]`

| Read configuration options from `properties`. See doConfigure(const File&, log4cxx::spi::LoggerRepositoryPtr&) for the expected format.

static void configure | ( | const File & | configFilename | ) | `[static]`

| Read configuration options from file `configFilename`.

static void configureAndWatch | ( | const File & | configFilename,
|  | long | delay
| ) | `[static]`

  | Read the configuration file `configFilename` if it exists. Moreover, a thread will be created that will periodically check if `configFilename` has been created or modified. The period is determined by the `delay` argument. If a change or file creation is detected, then `configFilename` is read to configure log4j. Parameters:
  | configFilename | A file in key=value format.
  | delay | The delay in milliseconds to wait between each check.

static void configureAndWatch | ( | const File & | configFilename | ) | `[static]`

  | Like configureAndWatch(const File& configFilename, long delay) except that the default delay as defined by helpers::FileWatchdog::DEFAULT_DELAY is used. Parameters:
  | configFilename | A file in key=value format.

void configureLoggerFactory | ( | helpers::Properties & | props | ) | `[protected]`

| Check the provided `Properties` object for a loggerFactory entry specified by LOGGER_FACTORY_KEY. If such an entry exists, an attempt is made to create an instance using the default constructor. This instance is used for subsequent Logger creations within this configurator. See also: parseCatsAndRenderers

void configureRootLogger | ( | helpers::Properties & | props,
|  | spi::LoggerRepositoryPtr & | hierarchy
| ) | `[protected]`

void doConfigure | ( | helpers::Properties & | properties,
|  | spi::LoggerRepositoryPtr & | hierarchy
| ) |

| Read configuration options from `properties`. See doConfigure(const File&, log4cxx::spi::LoggerRepositoryPtr&) for the expected format.

void doConfigure | ( | const File & | configFileName,
|  | spi::LoggerRepositoryPtr & | hierarchy
| ) | `[virtual]`

| Read configuration from a file. The existing configuration is not cleared nor reset. If you require a different behavior, then call resetConfiguration method before calling `doConfigure`. The configuration file consists of statements in the format `key=value`. The syntax of different configuration elements are discussed below. ### Repository-wide threshold The repository-wide threshold filters logging requests by level regardless of logger. The syntax is:
    log4j.threshold=[level]
The level value can consist of the string values OFF, FATAL, ERROR, WARN, INFO, DEBUG, ALL or a custom level value. A custom level value can be specified in the form level::classname. By default the repository-wide threshold is set to the lowest possible value, namely the level `ALL`. ### Appender configuration Appender configuration syntax is:
    # For appender named appenderName, set its class.
    # Note: The appender name can contain dots.
    log4j.appender.appenderName=fully.qualified.name.of.appender.class
    # Set appender specific options.
    log4j.appender.appenderName.option1=value1
    ...
    log4j.appender.appenderName.optionN=valueN
For each named appender you can configure its Layout. The syntax for configuring an appender's layout is:
    log4j.appender.appenderName.layout=fully.qualified.name.of.layout.class
    log4j.appender.appenderName.layout.option1=value1
    ....
    log4j.appender.appenderName.layout.optionN=valueN
### Configuring loggers The syntax for configuring the root logger is:
    log4j.rootLogger=[level], appenderName, appenderName, ...
This syntax means that an optional level can be supplied followed by appender names separated by commas. The level value can consist of the string values OFF, FATAL, ERROR, WARN, INFO, DEBUG, ALL or a custom level value. A custom level value can be specified in the form `level::classname`. If a level value is specified, then the root level is set to the corresponding level. If no level value is specified, then the root level remains untouched. The root logger can be assigned multiple appenders. Each appenderName (separated by commas) will be added to the root logger. The named appender is defined using the appender syntax defined above. For non-root categories the syntax is almost the same:
    log4j.logger.logger_name=[level|INHERITED|NULL], appenderName, appenderName,
    ...
The meaning of the optional level value is discussed above in relation to the root logger. In addition however, the value INHERITED can be specified meaning that the named logger should inherit its level from the logger hierarchy. If no level value is supplied, then the level of the named logger remains untouched. By default categories inherit their level from the hierarchy. However, if you set the level of a logger and later decide that that logger should inherit its level, then you should specify INHERITED as the value for the level value. NULL is a synonym for INHERITED. Similar to the root logger syntax, each appenderName (separated by commas) will be attached to the named logger. See the appender additivity rule in the user manual for the meaning of the `additivity` flag. ### Logger Factories The usage of custom logger factories is discouraged and no longer documented. ### Example An example configuration is given below. Other configuration file examples are given in the `examples` folder.
    # Set options for appender named "A1".
    # Appender "A1" will be a SyslogAppender
    log4j.appender.A1=SyslogAppender
    # The syslog daemon resides on www.abc.net
    log4j.appender.A1.SyslogHost=www.abc.net
    # A1's layout is a PatternLayout, using the conversion pattern
    # r -5p c{2} M.L x - m

    . Thus, the log output will
    # include # the relative time since the start of the application in
    # milliseconds, followed by the level of the log request,
    # followed by the two rightmost components of the logger name,
    # followed by the callers method name, followed by the line number,
    # the nested disgnostic context and finally the message itself.
    # Refer to the documentation of PatternLayout for further information
    # on the syntax of the ConversionPattern key.
    log4j.appender.A1.layout=PatternLayout
    log4j.appender.A1.layout.ConversionPattern=-4r -5p c{2} M.L x - m
    # Set options for appender named "A2"
    # A2 should be a RollingFileAppender, with maximum file size of 10 MB
    # using at most one backup file. A2's layout is TTCC, using the
    # ISO8061 date format with context printing enabled.
    log4j.appender.A2=RollingFileAppender
    log4j.appender.A2.MaxFileSize=10MB
    log4j.appender.A2.MaxBackupIndex=1
    log4j.appender.A2.layout=TTCCLayout
    log4j.appender.A2.layout.ContextPrinting=enabled
    log4j.appender.A2.layout.DateFormat=ISO8601
    # Root logger set to DEBUG using the A2 appender defined above.
    log4j.rootLogger=DEBUG, A2
    # Logger definitions:
    # The SECURITY logger inherits is level from root. However, it's output
    # will go to A1 appender defined above. It's additivity is non-cumulative.
    log4j.logger.SECURITY=INHERIT, A1
    log4j.additivity.SECURITY=false
    # Only warnings or above will be logged for the logger "SECURITY.access".
    # Output will go to A1.
    log4j.logger.SECURITY.access=WARN
    # The logger "class.of.the.day" inherits its level from the
    # logger hierarchy.  Output will go to the appender's of the root
    # logger, A2 in this case.
    log4j.logger.class.of.the.day=INHERIT
  Refer to the setOption method in each Appender and Layout for class specific options. Use the `#` or `!` characters at the beginning of a line for comments. Parameters:
  | configFileName | The name of the configuration file where the configuration information is stored.
  | hierarchy | The hierarchy to operation upon.
Implements Configurator.

void parseAdditivityForLogger | ( | helpers::Properties & | props,
|  | LoggerPtr & | cat,
|  | const LogString & | loggerName
| ) | `[protected]`

| Parse the additivity option for a non-root logger.

AppenderPtr parseAppender | ( | helpers::Properties & | props,
|  | const LogString & | appenderName
| ) | `[protected]`

void parseCatsAndRenderers | ( | helpers::Properties & | props,
|  | spi::LoggerRepositoryPtr & | hierarchy
| ) | `[protected]`

| Parse non-root elements, such non-root categories and renderers.

void parseLogger | ( | helpers::Properties & | props,
|  | LoggerPtr & | logger,
|  | const LogString & | optionKey,
|  | const LogString & | loggerName,
|  | const LogString & | value
| ) | `[protected]`

| This method must work for the root logger as well.

AppenderPtr registryGet | ( | const LogString & | name | ) | `[protected]`

void registryPut | ( | const AppenderPtr & | appender | ) | `[protected]`

void releaseRef | ( |  | ) | const`[virtual]`

| Reimplemented from ObjectImpl.

## Member Data Documentation

helpers::ObjectPtrT<spi::LoggerFactory> loggerFactory`[protected]`

| Used to create new instances of logger.

std::map<LogString, AppenderPtr>* registry`[protected]`

| Used internally to keep track of configured appenders.

The documentation for this class was generated from the following file:

- propertyconfigurator.h